#!/bin/sh

if [ ! "`pwd`" = "/" ]; then ##Woof build

 echo "Installing JWMdesk"

else ##conventional PET install

 #set first-run autohide parameter to "off" in JWM vgit >=1026 and standard releases >= 2.3.0
 if [ -d /usr/local/jwm_config* ]; then
  JWM_HOME="/root/.jwm"
  jwmtray="jwmrc-tray1"
 else
  JWM_HOME="/root"
  jwmtray=".jwmrc-tray"
 fi

 JWM_VER=$(jwm -v | head -n1 | cut -d " " -f2- | cut -d " " -f1 | sed -e 's/[snvgit-]//g')
 if [ "`jwm -v | head -n1 | grep -aE 'vgit|vsvn' 2>/dev/null`" ]; then
  if ((`bc <<< "$JWM_VER>=1026"`)); then
   sed -i -e 's#autohide="true"#autohide="off"#' -e 's#autohide="false"#autohide="off"#' $JWM_HOME/$jwmtray
   sed -i -e 's#autohide="bottom"#autohide="off"#' -e 's#autohide="top"#autohide="off"#' $JWM_HOME/$jwmtray
  fi
 elif [ "`echo "$JWM_VER" | grep -aE '^2\.3\.[0-9]|^2\.[4-9]|^[3-9]' 2>/dev/null`" ]; then
   sed -i -e 's#autohide="true"#autohide="off"#' -e 's#autohide="false"#autohide="off"#' $JWM_HOME/$jwmtray
   sed -i -e 's#autohide="bottom"#autohide="off"#' -e 's#autohide="top"#autohide="off"#' $JWM_HOME/$jwmtray
 fi

 #reset preferences to default state
 if [ -d /usr/local/jwmdesk/preferences ]; then
  rm -f /usr/local/jwmdesk/preferences/*
  echo "10" > /usr/local/jwmdesk/preferences/max-files
  if [ ! -d /usr/local/jwm_config* ]; then #check for current tray2
   if [ "`grep -aFi -- '<Tray ' $HOME/.jwmrc-tray2 2>/dev/null`" ]; then
    echo "true" > /usr/local/jwmdesk/preferences/accessory_tray
     if [ "`grep -aFi -- '<Tray ' $HOME/.jwmrc-tray2_hybrid 2>/dev/null`" ]; then
      echo "true" > /usr/local/jwmdesk/preferences/autohide_hybrid
     fi
   fi
  fi
 fi

 #remove deprecated files from prior releases of jwmdesk
 [ -f /usr/local/jwmdesk/set_tray_format ] && rm -f /usr/local/jwmdesk/set_tray_format
 [ -d /usr/local/jwmdesk/jwm_button_themes/Gnome ] && rm -r /usr/local/jwmdesk/jwm_button_themes/Gnome

 #convert menubutton svg icons of jwmdesk to png format if jwm is ancient (vgit<976)
 if [ "`jwm -v | head -n1 | grep -aE 'vgit|vsvn' 2>/dev/null`" ]; then
  if ((`bc <<< "$JWM_VER<976"`)); then
   if [ "`which rsvg-convert`" ]; then
     ICONDIR="/usr/local/jwmdesk/jwm_menubutton_icons"
     ICONS=`ls $ICONDIR | grep -a '\.svg'`
     for i in $ICONS
       do
         FILENAME="${i##*/}" #with extension
         FILENAMEnx="${FILENAME%.*}" #no extension
         rsvg-convert -f png -o $ICONDIR/$FILENAMEnx.png $ICONDIR/$i
       done
     rm -f $ICONDIR/*.svg
   fi
  fi
 fi

 . /etc/DISTRO_SPECS

 #update gtkdialog path for treeicons
 /usr/local/jwmdesk/treeicons

 #create icon symlinks to support non-path treeicons in Slacko-6.3.0.X (not required for subsequent Slackos)
 if [[ $(echo $DISTRO_NAME | grep -i slacko) ]]; then
  if [[ $(echo $DISTRO_VERSION | grep '6\.3\.0') ]]; then
   ls /usr/share/pixmaps/puppy | sort > /tmp/tmp
    while read -r icon
     do
       [ ! -f /usr/share/pixmaps/"$icon" ] && ln -snf /usr/share/pixmaps/puppy/"$icon" /usr/share/pixmaps/
     done < /tmp/tmp
  fi
 fi

 #check default apps for categories and icons
 [ -f /usr/share/applications/defaultaudioplayer.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultaudioplayer.desktop`" ] && echo "Categories=Audio" >> /usr/share/applications/defaultaudioplayer.desktop
 [ -f /usr/share/applications/defaultbrowser.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultbrowser.desktop`" ] && echo "Categories=X-Internet-browser" >> /usr/share/applications/defaultbrowser.desktop
 [ -f /usr/share/applications/defaultchmviewer.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultchmviewer.desktop`" ] && echo "Categories=X-Document-viewer" >> /usr/share/applications/defaultchmviewer.desktop
 [ -f /usr/share/applications/defaultimageviewer.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultimageviewer.desktop`" ] && echo "Categories=Presentation" >> /usr/share/applications/defaultimageviewer.desktop
 [ -f /usr/share/applications/defaultmediaplayer.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultmediaplayer.desktop`" ] && echo "Categories=AudioVideo" >> /usr/share/applications/defaultmediaplayer.desktop
 [ -f /usr/share/applications/defaultpdfviewer.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultpdfviewer.desktop`" ] && echo "Categories=X-Document-viewer" >> /usr/share/applications/defaultpdfviewer.desktop
 [ -f /usr/share/applications/defaultspreadsheet.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultspreadsheet.desktop`" ] && echo "Categories=X-Business-spreadsheet" >> /usr/share/applications/defaultspreadsheet.desktop
 [ -f /usr/share/applications/defaulttexteditor.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaulttexteditor.desktop`" ] && echo "Categories=TextEditor" >> /usr/share/applications/defaulttexteditor.desktop
 [ -f /usr/share/applications/defaultwordprocessor.desktop ] && [ ! "`grep -a '^Categories' /usr/share/applications/defaultwordprocessor.desktop`" ] && echo "Categories=WordProcessor" >> /usr/share/applications/defaultwordprocessor.desktop

 [ -f /usr/share/applications/defaultaudioplayer.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultaudioplayer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/multimedia48.png" >> /usr/share/applications/defaultaudioplayer.desktop
 [ -f /usr/share/applications/defaultbrowser.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultbrowser.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/www48.png" >> /usr/share/applications/defaultbrowser.desktop
 [ -f /usr/share/applications/defaultimageviewer.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultimageviewer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/draw48.png" >> /usr/share/applications/defaultimageviewer.desktop
 [ -f /usr/share/applications/defaultmediaplayer.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultmediaplayer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/multimedia48.png" >> /usr/share/applications/defaultmediaplayer.desktop
 [ -f /usr/share/applications/defaultpdfviewer.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultpdfviewer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/folder48.png" >> /usr/share/applications/defaultpdfviewer.desktop
 [ -f /usr/share/applications/defaultspreadsheet.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultspreadsheet.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/spread48.png" >> /usr/share/applications/defaultspreadsheet.desktop
 [ -f /usr/share/applications/defaulttexteditor.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaulttexteditor.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/edit48.png" >> /usr/share/applications/defaulttexteditor.desktop
 [ -f /usr/share/applications/defaultwordprocessor.desktop ] && [ ! "`grep -a '^Icon' /usr/share/applications/defaultwordprocessor.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/word48.png" >> /usr/share/applications/defaultwordprocessor.desktop

 #check missing images in icon themes
 THEMES=`ls /usr/local/lib/X11/themes | sort`
 for i in $THEMES 
   do
     if [ -d /usr/local/lib/X11/themes/$i ]; then
      if [ -f /usr/local/lib/X11/themes/$i/games24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/games48.png ]; then
       cp -f /usr/local/lib/X11/themes/$i/games24.png /tmp/tmp
       mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/games48.png
      fi
      if [ -f /usr/local/lib/X11/themes/$i/pc24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/pc48.png ]; then
       cp -f /usr/local/lib/X11/themes/$i/pc24.png /tmp/tmp
       mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/pc48.png
      fi
      if [ -f /usr/local/lib/X11/themes/$i/shutdown24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/shutdown48.png ]; then
       cp -f /usr/local/lib/X11/themes/$i/shutdown24.png /tmp/tmp
       mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/shutdown48.png
      fi
      if [ -f /usr/local/lib/X11/themes/$i/utility24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/utility48.png ]; then
       cp -f /usr/local/lib/X11/themes/$i/utility24.png /tmp/tmp
       mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/utility48.png
      fi
      if [ -f /usr/local/lib/X11/themes/$i/x24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/x48.png ]; then
       cp -f /usr/local/lib/X11/themes/$i/x24.png /tmp/tmp
       mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/x48.png
      fi
      if [ -f /usr/local/lib/X11/themes/$i/x.png ] && [ ! -f /usr/local/lib/X11/themes/$i/x48.png ]; then
       cp -f /usr/local/lib/X11/themes/$i/x.png /tmp/tmp
       mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/x48.png
      fi
     fi
   done
   [ ! -f /usr/local/lib/X11/pixmaps/pc48.png ] && [ -f /usr/local/lib/X11/pixmaps/pc24.png ] && cp -f /usr/local/lib/X11/pixmaps/pc24.png /tmp/tmp && mv -f /tmp/tmp /usr/local/lib/X11/pixmaps/pc48.png

 #update JWMdesk icons for ubuntupup64 >= Fossapup64
 DISTRO_VERSION="${DISTRO_VERSION:0:2}"
 if [ "$DISTRO_BINARY_COMPAT" = "ubuntu" ] && [ $(echo "$DISTRO_NAME" | grep -o 'pup64') ] && (( $(echo "$DISTRO_VERSION >= 9" |bc -l) )); then
  ICONDIR1="/usr/local/jwmdesk/icons"
  ICONDIR2="/usr/share/icons/PMaterial/scalable"
  if [ -d $ICONDIR2 ]; then
   cp $ICONDIR2/actions/select-color.svg /tmp/tmp && mv -f /tmp/tmp $ICONDIR1/windows.svg
   ln -sf $ICONDIR2/actions/apply.svg $ICONDIR1/apply.svg
   ln -sf $ICONDIR2/actions/clear.svg $ICONDIR1/clear.svg
   ln -sf $ICONDIR2/categories/application-x-executable.svg $ICONDIR1/default_apps.svg
   ln -sf $ICONDIR2/places/desktop.svg $ICONDIR1/desktop.svg
   ln -sf $ICONDIR2/categories/preferences-desktop-font.svg $ICONDIR1/font.svg
   ln -sf $ICONDIR2/devices/harddisk.svg $ICONDIR1/harddisk.svg
   ln -sf $ICONDIR2/actions/help.svg $ICONDIR1/help.svg
   ln -sf $ICONDIR2/categories/desktop-keyboard.svg $ICONDIR1/keyboard_shortcut.svg
   ln -sf $ICONDIR2/categories/preferences.svg $ICONDIR1/preferences.svg
   ln -sf $ICONDIR2/actions/quit.svg $ICONDIR1/quit.svg
   ln -sf $ICONDIR2/categories/preferences-desktop-screensaver.svg $ICONDIR1/screen_blank.svg
   ln -sf $ICONDIR2/categories/applications-graphics.svg $ICONDIR1/wallpaper.svg
   ln -sf $ICONDIR1/windows.svg $ICONDIR1/jwm_themes.svg
  fi
  echo "true" > /usr/local/jwmdesk/preferences/button_options
  [ -f /usr/sbin/darkmode-fossa ] && echo "true" > /usr/local/jwmdesk/preferences/dark_mode_toggle
 fi

 #check psync support of hwclock --verbose parameter
 hwclock --help > /tmp/psync_update
 if [ "`grep -- --verbose /tmp/psync_update 2>/dev/null`" ]; then
  if [ "`grep -- '^hwclock --debug' /usr/local/psync/psync 2>/dev/null`" ]; then
   sed -i 's/^hwclock --debug/hwclock --verbose/' /usr/local/psync/psync
  fi
  if [ "`grep -- '^hwclock --debug' /usr/sbin/psync 2>/dev/null`" ]; then
   sed -i 's/^hwclock --debug/hwclock --verbose/' /usr/sbin/psync
  fi
 fi
fi

#END
