#!/bin/sh
#copyright 01micko 2011
#GPL3 see /usr/share/doc/legal/
#NO warranty
# simple prog to arrange desk icons
#ver="0.8" #120531
#121224 rodin.s update for i18n
#150115 radky: if not Slacko, exclude Spup/Slacko option; add deskicons.svg and driveicons.svg; enable restart of X-server in openbox/openbox-session and lxsession (func file); window-position=2; define $GTKDIALOG
#160312 radky: remove obsolete icon options for legacy lupu, luci and spup; add option for 'trash icon only'
#160712 radky: adjust check for rox running (call busybox ps else standard ps)
#161219 radky: minor code adjustment
#180925 radky: remove option for 'no drive icons' (woof-ce no longer supports)
#210515 radky: adjust default location of trash icon (for minimal and 'trash only' puppypins); support EasyOS puppypins
#210530 radky: add adjustable edge-gap option for desk icons to accommodate trays at screen top
#210615 radky: add option to enable/disable desk icon labels
#211031 radky: adjust filemanager option in /usr/local/desksetup/func
#220202 radky: enable left-side trash icon if TRASHX variable supported
#220522 radky: adjust/abbreviate EasyOS desk icon labels and remove traditional Puppypin option from EasyOS

export TEXTDOMAIN=desksetup
export OUTPUT_CHARSET=UTF-8

APPDIR="`dirname $0`"
[ "$APPDIR" = "." ] && APPDIR="`pwd`"
export APPDIR="$APPDIR"

export ICONDIR=/usr/local/jwmdesk/icons
export PIXMAPDIR=/usr/share/pixmaps

mkdir -p /tmp/desksetup

[ "`which gtkdialog4 2>/dev/null`" ] && GTKDIALOG=gtkdialog4 || GTKDIALOG=gtkdialog
export GTKDIALOG

# application icons
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<svg height=\"100\" width=\"100\">
  <rect style=\"fill:#e1e1e1;stroke:#000000;stroke-width:1.5\" width=\"94\" height=\"80\" x=\"3\" y=\"10\"/>
  <rect style=\"fill:#666666\" width=\"92\" height=\"10\" x=\"4\" y=\"79\"/>
  <rect style=\"fill:#555555\" width=\"10\" height=\"10\" x=\"11\" y=\"18\"/>
  <rect style=\"fill:#333333\" width=\"10\" height=\"10\" x=\"11\" y=\"33\"/>
  <rect style=\"fill:#777777\" width=\"10\" height=\"10\" x=\"11\" y=\"48\"/>
</svg>" > /usr/share/pixmaps/deskicons.svg

echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<svg height=\"100\" width=\"100\">
  <path style=\"fill:#333333;stroke:#333333;stroke-width:3\" d=\"M 4.2,61 18,22 c 0,0 0,-2 5,-2 7,0 47,0 52,0 6,0 6,2 6,2 l 15,41 c 0,0 1,2 1,9 0,10 0,15 0,20 0,5 -4,5 -4,5 L 8.2,97 c 0,0 -6,1 -6,-7 0,-9 0,-14 0,-20 0,-6 2,-9 2,-9 z\"/>
  <path style=\"fill:#777777;stroke:#777777;stroke-width:2.5\" d=\"m 5.2,70 0,21 c 0,4 1.2,4 3.8,4 l 80,0 c 3,0 5,0 5,-5 l 0,-20\"/>
  <path style=\"fill:#999999;stroke:#dddddd;stroke-width:2.5\" d=\"M 6.2,63 20,24 c 0,0 1,-2 4,-2 5,0 47,0 51,0 3,0 4,2 4,2 0,0 13,35 14,39 1,4 3,8 -5,8 -6,0 -78,0 -78,0 -6.8,0 -4.8,-4 -3.8,-8 z\"/>
  <path style=\"fill:#eeeeee;\" d=\"m 50,31 c 16,0 31,6 33,16 2,9 -9,20 -32,20 C 25,67 14,55 16,46 18,36 34,31 50,31 z\"/>
  <path style=\"fill:#bbbbbb;\" d=\"M 50,31 C 66,31 81,37 83,47 85,56 69,64 51,64 30,64 14,55 16,46 18,36 34,31 50,31 z\"/>
  <path style=\"fill:#cccccc;\" d=\"m 87,62 c 4,0 4,5 0,5 -4,0 -4,-5 0,-5 z m -75,0 c 4,0 4,5 0,5 -3.8,0 -3.8,-5 0,-5 z\"/>
  <path style=\"fill:#999999;stroke:#555555\" d=\"m 13,77 74,0 0,14 -74,0 z\"/>
  <path style=\"fill:none;stroke:#999999;stroke-width:1.5\" d=\"m 85,77 0,14 m -4,-14 0,14 m -4,-14 0,14 m -4,-14 0,14 m -4,-14 0,14 m -4,-14 0,14\"/>
  <path style=\"fill:#222222\" d=\"m 50,32 4,5 -3,0 0,12 7,-3 0,-2 -2,0 0,-5 6,0 0,5 -2,0 0,3 -9,4 0,6 c 0,0 2,1 2,3 0,2 -1,3 -3,3 -2,0 -3,-1 -3,-3 0,-2 2,-3 2,-3 l 0,-2 -9,-5 0,-4 c 0,0 -2,-1 -2,-3 0,-1 1,-3 3,-3 2,0 3,2 3,3 0,2 -2,3 -2,3 l 0,3 7,4 0,-16 -3,0 z\"/>
</svg>
" > /usr/share/pixmaps/driveicons.svg

# help dialog
gettext "<b><span size='"'x-large'"'>Desktop Icon Setup</span></b>

<b>Restart of Graphical Server</b>
When the Apply button is selected the graphical server will restart. Before proceeding, please save your desktop work and close other applications.

<b>Desk Icon Labels</b>
The <i>Icon Label</i> option will enable or disable descriptive labels for desk icons. Removing icon labels may be of interest to those who prefer a simple intuitive desktop.

<b>Screen Edge Gap</b>
The <i>Screen Edge Gap</i> option will adjust the space above the desktop icons to accommodate placement of the main JWM tray at the screen top. Generally, selecting an edge gap of at least 50px greater than the tray short-dimension will provide a good starting point for comfortable viewing. To adjust the tray short-dimension, please go to the Tray tab of JWMdesk.

<b>Copy to Desktop</b>
This option opens the /usr/share/applications directory in a RoxFiler window where one may select applications to drag and drop to the desktop.

<b>Custom Pinboard</b>
The fixPuppyPin utility of Puppy Linux finds the x-coordinates of the Xlock icon and moves that icon (and other icons with the same x-coordinates) to the right side of the screen. However, the Xlock icon is not included in the Minimal-essential or Trash-only options of the Icon Layout application. This release adjusts the RIGHTX variable of fixPuppyPin to include the position of the Trash icon as a determining factor for the right border of desk icons. Additionally, the default position of the Trash icon is now along the right side of the screen.

If you create and save a customized layout of desk icons, please keep in mind the position of the Xlock or Trash icons on the right side of the screen (if included in your custom profile) will assure other icons with the same x-coordinates will be relocated to the correct right side.

<b>Drive Icon Layout</b>
On the Drive Icons tab of the main interface the <i>Icon Layout</i> option will launch the Puppy Event Manager where you can adjust the placement, edge gap and spacing of drive and partition icons." > /tmp/desksetup/desksetup_help

desksetup_help()
{
export Help='
<window default-height="450" default-width="560" title="'$(gettext 'Help')'" icon-name="deskicons" window-position="1" resizable="true">
<vbox height-request="450" width-request="560" space-expand="true" space-fill="true">
	<vbox space-expand="true" space-fill="true">
		<vbox scrollable="true" shadow-type="3" space-expand="true" space-fill="true">
			<vbox space-expand="false" space-fill="false">
				<text xpad="20" ypad="15" use-markup="true"><input file>/tmp/desksetup/desksetup_help</input></text>
			</vbox>
		</vbox>
	</vbox>
	<hbox space-expand="false" space-fill="false">
		<button width-request="100">
			<label>'$(gettext 'Close')'</label>
		</button>
	</hbox>
</vbox>
</window>'

$GTKDIALOG -p Help
unset Help
}
export -f desksetup_help

# set headers
XML_INFO_COLOR='#EDEBD7' # background color
XML_INFO_OPACITY=0.5 # background opacity
. $APPDIR/xml_info_desksetup gtk > /dev/null # build bg_pixmap for gtk-theme

BOX_HEIGHT=90 # HEADER_1
ICON=$PIXMAPDIR/deskicons.svg
ICON_HEIGHT=60
MSG_1="<b><span size='"'x-large'"'>$(gettext "Desk Icons")</span></b>"
MSG_2="<b>$(gettext "Set layout and position of desk icons")</b>"
ALIGN=left # center or left
HEADER_1="
	<hbox height-request="'"${BOX_HEIGHT}"'">
	$(. $APPDIR/xml_info_desksetup "$ICON" "$ICON_HEIGHT" "$MSG_1" "$MSG_2" "$ALIGN")
	</hbox>"

BOX_HEIGHT=90 # HEADER_2
ICON=$PIXMAPDIR/driveicons.svg
ICON_HEIGHT=60
MSG_1="<b><span size='"'x-large'"'>$(gettext "Drive Icons")</span></b>"
MSG_2="<b>$(gettext "Set layout of drive icons")</b>"
ALIGN=left # center or left
HEADER_2="
	<hbox height-request="'"${BOX_HEIGHT}"'">
	$(. $APPDIR/xml_info_desksetup "$ICON" "$ICON_HEIGHT" "$MSG_1" "$MSG_2" "$ALIGN")
	</hbox>"

# is rox running? #160712
if [ "`which busybox`" ]; then
	ROXRUNNING=`busybox ps|grep -a "/usr/local/apps/ROX-Filer/ROX-Filer -p /root/Choices/ROX-Filer/PuppyPin"|grep -av "grep"`
else
	ROXRUNNING=`ps -ax|grep -a "/usr/local/apps/ROX-Filer/ROX-Filer -p /root/Choices/ROX-Filer/PuppyPin"|grep -av "grep"`
fi
[ ! "$ROXRUNNING" ] && gtkdialog-splash -icon /usr/local/desksetup/icons/dialog-error.svg -timeout 5 -deco deskset -fontsize large -bg hotpink -close never -text " $(gettext "ERROR: Rox pinboard (PuppyPin) is not running") " && exit

[ -x /usr/local/bin/roxfiler ] && ROX=/usr/local/bin/roxfiler || ROX=/usr/local/bin/rox

# eventmanager has a bug where pristine it has double quotes arround bool statements, after evenmanager is run they disappear
HASQUOTES=`grep '"' /etc/eventmanager`
if [[ "$HASQUOTES" != "" ]];then #110120
	sed -i 's/\"//g' /etc/eventmanager
fi 

. /etc/eventmanager
# get radio defaults for drive icons from /etc/eventmanager
TABLABEL="$(gettext 'Desk Icons')"
DRIVEICONS=""

if [ "$ICONDESK" -a "$ICONPARTITIONS" ]; then
 if [[ "$ICONDESK" = "false" && "$ICONPARTITIONS" = "true" ]];then
  RADIO6=false
  RADIO7=false
  RADIO8=false
  elif [[ "$ICONDESK" = "true" && "$ICONPARTITIONS" = "true" ]];then
   RADIO6=true
   RADIO7=false
   RADIO8=false
  elif [[ "$ICONDESK" = "true" && "$ICONPARTITIONS" = "false" ]];then
   RADIO6=false
   RADIO7=true
   RADIO8=false
  elif [[ "$ICONDESK" = "false" && "$ICONPARTITIONS" = "false" ]];then
   RADIO6=false
   RADIO7=false
   RADIO8=true
 fi

 TABLABEL="$(gettext 'Desk Icons|Drive Icons')"

 DRIVEICONS="
  <vbox>
	${HEADER_2}
	<vbox space-expand=\"false\" space-fill=\"false\">
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Each partition will have its own icon - as will plugged drives ')\">
			<label>\"$(gettext 'Traditional - an icon for each partition')\"</label>
			<variable>RADIO6</variable>
			<default>$RADIO6</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Root drive icons only - no partition icons ')\">
			<label>\"$(gettext 'Lean - only root drive icons')\"</label>
			<variable>RADIO7</variable>
			<default>$RADIO7</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' One drive icon which starts Pmount ')\">
			<label>\"$(gettext 'Minimal - one drive icon')\"</label>
			<variable>RADIO8</variable>
			<default>$RADIO8</default>
		</radiobutton>
	</vbox>
	<text space-expand=\"true\" space-fill=\"true\"><label>\" \"</label></text>
	<hbox space-expand=\"false\" space-fill=\"false\">
		<text><label>\" $(gettext 'Drive icon layout'):\"</label></text>
		<button width-request=\"120\" tooltip-text=\" $(gettext 'Adjust the placement and spacing of drive icons') \">
			<input file>$ICONDIR/manage.svg</input><height>22</height><width>22</width>
			<action>eventmanager desktop &</action>
		</button>
	</hbox>
  </vbox>"
fi

# define config dir/file
	CONFDIR="$HOME/.desksetup"
	CONFFILE="$CONFDIR/desk.conf"
# export $CONFFILE
	cp -af $CONFFILE ${CONFFILE}.bak
	. $CONFFILE

# define trash icon position (trash icon only) 
	LEFT_TRASH_OPTION=""
	if [ "`grep 'TRASHX' /usr/sbin/fixPuppyPin 2>/dev/null`" ]; then
		LEFT_TRASH=$(cat $CONFDIR/left-trash 2>/dev/null)
		[ ! "$LEFT_TRASH" ] && LEFT_TRASH=false && echo "false" > $CONFDIR/left-trash
		cp -af $CONFDIR/left-trash $CONFDIR/left-trash.bak
		[ "$RADIO4" = "true" ] && ss=true || ss=false
		LEFT_TRASH_OPTION="
		<checkbox sensitive=\"$ss\" height-request=\"30\" space-expand=\"false\" space-fill=\"false\" tooltip-text=\"$(gettext ' Move trash icon to left screen edge ')\">
			<label>\"$(gettext 'Left')\"</label>
			<variable>LEFT_TRASH</variable>
			<input file>$CONFDIR/left-trash</input>
			<action>if true echo true > $CONFDIR/left-trash</action>
			<action>if false echo false > $CONFDIR/left-trash</action>
		</checkbox>"
	else
		echo "false" > $CONFDIR/left-trash
		echo "false" > $CONFDIR/left-trash.bak
	fi

# define icon label
	ICON_LABEL=$(cat $CONFDIR/icon-label 2>/dev/null)
	[ ! "$ICON_LABEL" ] && ICON_LABEL=On && echo "On" > $CONFDIR/icon-label
	cp -af $CONFDIR/icon-label $CONFDIR/icon-label.bak

# define gap between desk icons and screen top
	EDGE_GAP=$(cat $CONFDIR/edge-gap 2>/dev/null)
	[ ! "$EDGE_GAP" ] && EDGE_GAP=32 && echo "32" > $CONFDIR/edge-gap
	cp -af $CONFDIR/edge-gap $CONFDIR/edge-gap.bak
	read ROOTDIMS MX MY << EOF
	`xwininfo -root | grep ' \-geometry ' | cut -f 1 -d '+' | tr 'x' ' '`
EOF
	MY="$(( 9*MY / 10 ))"
	[ ! "$MY" ] && MY="600"

# define radiobutton options
EASYOS=""
PUPPY="
		<hbox>
		<vbox space-expand=\"false\" space-fill=\"false\">
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Standard Puppy desktop ')\">
			<label>\"$(gettext 'Traditional - full desktop icons')\"</label>
			<variable>RADIO1</variable>
			<action>if true disable:LEFT_TRASH</action>
			<action>if true sed -i 's/RADIO1=[a-z]*[a-z]/RADIO1=true/' $CONFFILE</action>
			<action>if true echo false > $CONFDIR/left-trash</action>
			<action>refresh:LEFT_TRASH</action>
			<action>if false sed -i 's/RADIO1=[a-z]*[a-z]/RADIO1=false/' $CONFFILE</action>
			<default>$RADIO1</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Includes the file, console, browse and trash icons ')\">
			<label>\"$(gettext 'Minimal - essential desktop icons')\"</label>
			<variable>RADIO2</variable>
			<action>if true disable:LEFT_TRASH</action>
			<action>if true sed -i 's/RADIO2=[a-z]*[a-z]/RADIO2=true/' $CONFFILE</action>
			<action>if true echo false > $CONFDIR/left-trash</action>
			<action>refresh:LEFT_TRASH</action>
			<action>if false sed -i 's/RADIO2=[a-z]*[a-z]/RADIO2=false/' $CONFFILE</action>
			<default>$RADIO2</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' No application icons on the desktop ')\">
			<label>\"$(gettext 'Bare - no desktop icons')\"</label>
			<variable>RADIO3</variable>
			<action>if true disable:LEFT_TRASH</action>
			<action>if true sed -i 's/RADIO3=[a-z]*[a-z]/RADIO3=true/' $CONFFILE</action>
			<action>if true echo false > $CONFDIR/left-trash</action>
			<action>refresh:LEFT_TRASH</action>
			<action>if false sed -i 's/RADIO3=[a-z]*[a-z]/RADIO3=false/' $CONFFILE</action>
			<default>$RADIO3</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Single icon to manage deleted files ')\">
			<label>\"$(gettext 'Trash icon only - default on right')\"</label>
			<variable>RADIO4</variable>
			<action>if true enable:LEFT_TRASH</action>
			<action>if true sed -i 's/RADIO4=[a-z]*[a-z]/RADIO4=true/' $CONFFILE</action>
			<action>if false sed -i 's/RADIO4=[a-z]*[a-z]/RADIO4=false/' $CONFFILE</action>
			<default>$RADIO4</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' This will display your saved custom pinboard ')\">
			<label>\"$(gettext 'Custom - saved icon profile')\"</label>
			<variable>RADIO5</variable>
			<action>if true disable:LEFT_TRASH</action>
			<action>if true sed -i 's/RADIO5=[a-z]*[a-z]/RADIO5=true/' $CONFFILE</action>
			<action>if true echo false > $CONFDIR/left-trash</action>
			<action>refresh:LEFT_TRASH</action>
			<action>if false sed -i 's/RADIO5=[a-z]*[a-z]/RADIO5=false/' $CONFFILE</action>
			<default>$RADIO5</default>
		</radiobutton>
		</vbox>
		<text space-expand=\"true\" space-fill=\"true\"><label>\" \"</label></text>
		<vbox space-expand=\"false\" space-fill=\"false\">
		<text height-request=\"30\"><label>\"\"</label></text>
		<text height-request=\"30\"><label>\"\"</label></text>
		<text height-request=\"30\"><label>\"\"</label></text>
		${LEFT_TRASH_OPTION}
		<text height-request=\"30\"><label>\"\"</label></text>
		</vbox>
		<text space-expand=\"true\" space-fill=\"true\"><label>\" \"</label></text>
		</hbox>"

if [ -d /usr/local/easy_version ]; then
 RADIO1=false #traditional puppypin (RADIO1) not applicable in EasyOS
 sed -i 's/RADIO1=[a-z]*[a-z]/RADIO1=false/' $CONFFILE
 PUPPY=""
 EASYOS="
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Standard EasyOS desktop ')\">
			<label>\"$(gettext 'Standard - full desktop icons')\"</label>
			<variable>RADIO2</variable>
			<action>if true sed -i 's/RADIO2=[a-z]*[a-z]/RADIO2=true/' $CONFFILE</action>
			<action>if false sed -i 's/RADIO2=[a-z]*[a-z]/RADIO2=false/' $CONFFILE</action>
			<default>$RADIO2</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Includes the files, term, www and trash icons ')\">
			<label>\"$(gettext 'Minimal - essential desktop icons')\"</label>
			<variable>RADIO3</variable>
			<action>if true sed -i 's/RADIO3=[a-z]*[a-z]/RADIO3=true/' $CONFFILE</action>
			<action>if false sed -i 's/RADIO3=[a-z]*[a-z]/RADIO3=false/' $CONFFILE</action>
			<default>$RADIO3</default>
		</radiobutton>
		<radiobutton height-request=\"30\" tooltip-text=\"$(gettext ' Saved custom pinboard must include www icon ')\">
			<label>\"$(gettext 'Custom - saved icon profile')\"</label>
			<variable>RADIO4</variable>
			<action>if true sed -i 's/RADIO4=[a-z]*[a-z]/RADIO4=true/' $CONFFILE</action>
			<action>if false sed -i 's/RADIO4=[a-z]*[a-z]/RADIO4=false/' $CONFFILE</action>
			<default>$RADIO4</default>
		</radiobutton>"
fi

# title-bar icon #140930
[ ! -f /usr/share/icons/hicolor/48x48/apps/deskicons.svg ] && \
ln -sf /usr/share/pixmaps/deskicons.svg /usr/share/icons/hicolor/48x48/apps && gtk-update-icon-cache -f -i /usr/share/icons/hicolor 2>/dev/null

# gui
export deskset="
<window title=\"$(gettext 'Desktop Icon Setup') $ver\"  icon-name=\"deskicons\" window-position=\"1\" resizable=\"false\">
 <vbox>
  <notebook labels=\"$TABLABEL\">
	<vbox>
	${HEADER_1}
	${PUPPY}
	${EASYOS}
	<hseparator></hseparator>
	<hbox space-expand=\"false\" space-fill=\"false\">
		<text><label>\"$(gettext 'Desk icon labels'):\"</label></text>
		<comboboxtext width-request=\"120\" tooltip-text=\" $(gettext 'Enable or disable icon labels') \">
			<variable>ICON_LABEL</variable>
			<default>$ICON_LABEL</default>
			<item>On</item>
			<item>Off</item>
			<action>echo \$ICON_LABEL > $CONFDIR/icon-label</action>
		</comboboxtext>
	</hbox>
	<hbox space-expand=\"false\" space-fill=\"false\">
	<text><label>\" $(gettext 'Screen edge gap'):\"</label></text>
		<spinbutton width-request=\"120\" range-min=\"32\" range-max=\"$MY\" range-step=\"2\" range-value=\"32\" tooltip-text=\" $(gettext 'Adjust the gap between desk icons and screen top') \">
			<variable>EDGE_GAP</variable>
			<input>cat $CONFDIR/edge-gap</input>
			<action>echo \$EDGE_GAP > $CONFDIR/edge-gap</action>
		</spinbutton>
	</hbox>
	<hbox space-expand=\"false\" space-fill=\"false\">
	<text><label>\" $(gettext 'Copy to desktop'):\"</label></text>
		<button width-request=\"120\" tooltip-text=\" $(gettext 'Drag and drop applications to desktop') \">
			<input file>$ICONDIR/backup.svg</input><height>22</height><width>22</width>
			<action>$ROX /usr/share/applications &</action>
		</button>
	</hbox>
	<hbox space-expand=\"false\" space-fill=\"false\">
	<text><label>\" $(gettext 'Custom pinboard'):\"</label></text>
		<button width-request=\"120\" tooltip-text=\" $(gettext 'Save custom layout of desk icons') \">
			<input file>$ICONDIR/save.svg</input><height>22</height><width>22</width>
			<action>. $APPDIR/func customsave &</action>
		</button>
	</hbox>
	</vbox>
  
	${DRIVEICONS}

  </notebook>

	<hbox space-expand=\"true\" space-fill=\"true\" homogeneous=\"true\">
		<button space-expand=\"true\" space-fill=\"true\" tooltip-text=\" $(gettext 'When Apply is clicked the graphical server will restart') \" use-underline=\"true\">
			<label>$(gettext '_Apply')</label>
			<input file>$ICONDIR/apply.svg</input><height>22</height><width>22</width>
			<action>. $APPDIR/func apply &</action>
			<action>exit:applied</action>
		</button>
		<button space-expand=\"true\" space-fill=\"true\" use-underline=\"true\">
			<label>$(gettext '_Help')</label>
			<input file>$ICONDIR/help.svg</input><height>22</height><width>22</width>
			<action>desksetup_help &</action>
		</button>
		<button space-expand=\"true\" space-fill=\"true\" use-underline=\"true\">
			<label>$(gettext '_Quit')</label>
			<input file>$ICONDIR/quit.svg</input><height>22</height><width>22</width>
			<action>cp -af ${CONFFILE}.bak $CONFFILE </action>
			<action>cp -af $CONFDIR/edge-gap.bak $CONFDIR/edge-gap </action>
			<action>cp -af $CONFDIR/icon-label.bak $CONFDIR/icon-label </action>
			<action>cp -af $CONFDIR/left-trash.bak $CONFDIR/left-trash </action>
			<action>exit:closed</action>
		</button>
	</hbox>
 </vbox>
</window>
"
$GTKDIALOG -p deskset --styles=/tmp/desksetup/gtkrc_xml_info.css
unset deskset
#end
